------------------------------------------------
-- Apply DML 
-- insert property for demographic file type processing
------------------------------------------------
merge into FCM_PROPERTY
USING TABLE(values('DBMAINT_DEMO_FILETYPE'))
                     ac(PROPERTY_NAME) 
                  ON (FCM_PROPERTY.PROPERTY_NAME = ac.PROPERTY_NAME)
when not matched then
INSERT 
(PROPERTY_NAME, PROPERTY_VALUE, PROPERTY_DESC, PROPERTY_LABEL, PROPERTY_TYPE, CREATE_TIMESTAMP,CREATE_USER,LSTUPDT_NBR,LOGICAL_DEL_IND,PROPERTY_EDITABLE_IND) 
VALUES
('DBMAINT_DEMO_FILETYPE', 'dlm', 'file type value: dlm', 'Demographic loader file type', 'sordbmaint',current timestamp,CURRENT USER,0,'0','1')
when  matched then
  UPDATE set PROPERTY_DESC = 'file type value: dlm'
ELSE IGNORE;

------------------------------------------------
-- Apply DML 
-- Insert new Role/Privilege associations
------------------------------------------------
insert into FCM_ROLE_PRIVILEGE (ROLE_ID,PRIVILEGE_ID,CREATE_USER,CREATE_TIMESTAMP,LSTUPDT_USER,LSTUPDT_TIMESTAMP,LSTUPDT_NBR,LOGICAL_DEL_IND) 
VALUES (
   (select role_id from fcm_role where role_name in ('Model Administrator'))
  ,(select PRIVILEGE_ID from fcm_privilege where system_privilege_name  in ('VIEWADMIN'))
  ,CURRENT USER  
  ,CURRENT_TIMESTAMP
  ,CURRENT USER  
  ,CURRENT_TIMESTAMP
  ,0   
  ,'0'  
);

insert into FCM_ROLE_PRIVILEGE (ROLE_ID,PRIVILEGE_ID,CREATE_USER,CREATE_TIMESTAMP,LSTUPDT_USER,LSTUPDT_TIMESTAMP,LSTUPDT_NBR,LOGICAL_DEL_IND)
VALUES (
   (select role_id from fcm_role where role_name in ('Console Administrator'))
  ,(select PRIVILEGE_ID from fcm_privilege where system_privilege_name  in ('VIEWADMIN'))
  ,CURRENT USER  
  ,CURRENT_TIMESTAMP
  ,CURRENT USER  
  ,CURRENT_TIMESTAMP
  ,0   
  ,'0'  
);

insert into FCM_ROLE_PRIVILEGE (ROLE_ID,PRIVILEGE_ID,CREATE_USER,CREATE_TIMESTAMP,LSTUPDT_USER,LSTUPDT_TIMESTAMP,LSTUPDT_NBR,LOGICAL_DEL_IND) 
VALUES (
   (select role_id from fcm_role where role_name in ('Console Administrator'))
  ,(select PRIVILEGE_ID from fcm_privilege where system_privilege_name  in ('DEPLRULE'))
  ,CURRENT USER  
  ,CURRENT_TIMESTAMP
  ,CURRENT USER  
  ,CURRENT_TIMESTAMP
  ,0   
  ,'0'  
);

------------------------------------------------
-- Apply DML 
-- Insert Last_rule_fired field for grids
------------------------------------------------
INSERT INTO FCM_FIELD_DEFINITION (
                FIELD_ID,
                SEGMENT_ID,
                FIELD_STARTING_POS,
                FIELD_LENGTH, 
                FIELD_NAME, 
                FIELD_BUSINESSNAME,
                FIELD_DESC,
                EX_SAS_VALUE,
                VARIABLE_TYPE,
                SAS_INFORMAT,
                SAS_FORMAT,
                SAS_AGS_BIN_INFORMAT_IND,
                C_VARIABLE_TYPE,
                JAVA_VARIABLE_TYPE,
                DBMS_VARIABLE_TYPE,
                FIELD_INITIAL_VALUE,
                SORT_ORDER,
                FIELD_RULE_ACCESSIBLE_IND,
                DATA_POP_ENABLED_IND,
                FIELD_VISIBLE_IND,
                EXPOSE_USERVAR_IND,
                DATA_POP_ATTR_VALUE,
                BEGIN_BUILD_ID,
                END_BUILD_ID,                                
                CREATE_USER, 
                CREATE_TIMESTAMP, 
                LSTUPDT_USER, 
                LSTUPDT_TIMESTAMP, 
                LSTUPDT_NBR,
                LOGICAL_DEL_IND,
                FIELD_DESC_EDIT, 
                FIELD_PERMANENT_SELECTION_IND,  
                FIELD_BUSINESSNAME_EDIT) 
SELECT
                -1 as FIELD_ID, 
                SUB.SEGMENT_ID as SEGMENT_ID,
                0 as FIELD_STARTING_POS,
                0 as FIELD_LENGTH,
                'last_rule_fired' as FIELD_NAME, 
                'Rule' as FIELD_BUSINESSNAME,
                'The last rule fired on the transaction.' as FIELD_DESC,
                ' ' as EX_SAS_VALUE,
                'Character' as VARIABLE_TYPE,
                '$char8.' as SAS_INFORMAT,  
                '$char8.' as SAS_FORMAT,
                '0' as SAS_AGS_BIN_INFORMAT_IND,
                ' ' as C_VARIABLE_TYPE,
                ' ' as JAVA_VARIABLE_TYPE,
                ' ' as DBMS_VARIABLE_TYPE,
                ' ' as FIELD_INITIAL_VALUE,
                0 as SORT_ORDER,
                '0' as FIELD_RULE_ACCESSIBLE_IND,
                '1' as DATA_POP_ENABLED_IND,
                '1' as FIELD_VISIBLE_IND,
                '0' as EXPOSE_USERVAR_IND,
                'ruleAlertReason' as DATA_POP_ATTR_VALUE,
                -1 as BEGIN_BUILD_ID,
                -1 as END_BUILD_ID,                                                                                                       
                'GRID LOADER' as CREATE_USER, 
                CURRENT TIMESTAMP - CURRENT TIMEZONE, 
                'GRID LOADER' as LSTUPDT_USER, 
                CURRENT TIMESTAMP - CURRENT TIMEZONE, 
                0 as LSTUPDT_NBR,
                '0' as LOGICAL_DEL_IND,
                'Last Rule Fired' as FIELD_DESC_EDIT,
                '0' as FIELD_PERMANENT_SELECTION_IND,
                'Rule' as FIELD_BUSINESSNAME_EDIT
FROM   
                (SELECT sd.SEGMENT_ID FROM FCM_SEGMENT_DEFINITION sd where sd.SEGMENT_ACRONYM='RRF') AS SUB;
                

INSERT  INTO FCM_GRID_TMPLT_FIELD_CFG (
                GRID_TEMPLATE_ID, ACCOUNT_TYPE_ID, TRANS_ACTIVITY_ID, GRID_FIELD_ID, FIELD_ORDER, FIELD_SELECTED_IND, GRID_FIELD_HEADER,
                GRID_FIELD_HEADER_DESC, FIELD_ALIGNMENT, DATA_POP_ENABLED_IND, ALL_TAB_ENABLED_IND, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER,
                LSTUPDT_TIMESTAMP, LSTUPDT_NBR)
SELECT  gt.GRID_TEMPLATE_ID,  ga.ACCOUNT_TYPE_ID as ACCOUNT_TYPE_ID,  gta.TRANS_ACTIVITY_ID as TRANS_ACTIVITY_ID, 
                -1 as GRID_FIELD_ID,  3 as FIELD_ORDER,  '1' as FIELD_SELECTED_IND, 
                fd.FIELD_BUSINESSNAME_EDIT as GRID_FIELD_HEADER,  fd.FIELD_DESC_EDIT as GRID_FIELD_HEADER_DESC,
                'Left' as FIELD_ALIGNMENT,  '1' as DATA_POP_ENABLED_IND,  '1' as ALL_TAB_ENABLED_IND,
                'GRID LOADER' as CREATE_USER,  (CURRENT TIMESTAMP - CURRENT TIMEZONE) AS CREATE_TIMESTAMP,
                'GRID LOADER' as LSTUPDT_USER,  (CURRENT TIMESTAMP - CURRENT TIMEZONE) AS LSTUPDT_TIMESTAMP,
                0 as LSTUPDT_NBR
FROM    FCM_GRID_ACCOUNT AS ga, FCM_GRID_TRANS_ACTIVITY AS gta, FCM_GRID_TMPLT AS gt, FCM_FIELD_DEFINITION AS fd
WHERE  SUBSTR(ga.ACCOUNT_TYPE_VALUE, 1,2) = SUBSTR(gta.TRANS_ACTIVITY_ACRONYM, 1,2) 
 AND fd.FIELD_ID = -1 AND gt.GRID_TEMPLATE_ID != -1;

 
 
------------------------------------------------
-- Apply DML 
-- insert new version information
------------------------------------------------
insert into fcm_version(VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) 
VALUES ('Base DDL', '3.1.2.2 ', current date, '3.1.2.2 Hotfix DDL', 'DDL');
